"
 Copyright (c) 2007-2010 Jan Vrany, SWING Research Group, Czech Technical University in Prague
 Copyright (c) 2009-2010 eXept Software AG

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libtool' }"

"{ NameSpace: Tools }"

SimpleDialog subclass:#LintRuleSelectionDialog
	instanceVariableNames:'selectionHolder variablePanel relativeCorners detailsShown
		listSelection rulesetList rulesetHolder rulesetNameList
		rulesetNameHolder'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Lint'
!

!LintRuleSelectionDialog class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2007-2010 Jan Vrany, SWING Research Group, Czech Technical University in Prague
 Copyright (c) 2009-2010 eXept Software AG

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
!

documentation
"
    documentation to be added.

    [author:]
        Jan Vrany (jv@neso)

    [instance variables:]

    [class variables:]

    [see also:]

"
!

examples
"
  Starting the application:
                                                                [exBegin]
    Tools::LintRuleSelectionDialog open

                                                                [exEnd]

  more examples to be added:
                                                                [exBegin]
    ... add code fragment for 
    ... executable example here ...
                                                                [exEnd]
"
! !

!LintRuleSelectionDialog class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:Tools::LintRuleSelectionDialog andSelector:#windowSpec
     Tools::LintRuleSelectionDialog new openInterface:#windowSpec
     Tools::LintRuleSelectionDialog open
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: windowSpec
        window: 
       (WindowSpec
          label: 'Select Lint Rules'
          name: 'Select Lint Rules'
          min: (Point 10 10)
          bounds: (Rectangle 0 0 600 400)
        )
        component: 
       (SpecCollection
          collection: (
           (ComboListSpec
              name: 'ComboBox1'
              layout: (LayoutFrame 0 0 0 0 0 1 25 0)
              model: rulesetNameHolder
              acceptOnPointerLeave: false
              comboList: rulesetNameList
            )
           (VariableVerticalPanelSpec
              name: 'VariableVerticalPanel1'
              layout: (LayoutFrame 0 0 30 0 0 1 -30 1)
              component: 
             (SpecCollection
                collection: (
                 (SubCanvasSpec
                    name: 'RuleList'
                    hasHorizontalScrollBar: false
                    hasVerticalScrollBar: false
                    majorKey: #'Tools::HierarchicalLintRuleList'
                    subAspectHolders: 
                   (Array
                      
                     (SubChannelInfoSpec
                        subAspect: inGeneratorHolder
                        aspect: allRulesHolder
                      ) 
                     (SubChannelInfoSpec
                        subAspect: listSelection
                        aspect: listSelection
                      )
                      
                     (SubChannelInfoSpec
                        subAspect: modeHolder
                        aspect: modeHolder
                      ) 
                     (SubChannelInfoSpec
                        subAspect: outGeneratorHolder
                        aspect: selectedRulesHolder
                      )
                      
                     (SubChannelInfoSpec
                        subAspect: selectionHolder
                        aspect: selectionHolder
                      )
                    )
                    createNewApplication: true
                    createNewBuilder: true
                  )
                 (SubCanvasSpec
                    name: 'RuleDesc'
                    hasHorizontalScrollBar: false
                    hasVerticalScrollBar: false
                    majorKey: #'Tools::LintRuleDetail'
                    subAspectHolders: 
                   (Array
                      
                     (SubChannelInfoSpec
                        subAspect: ruleHolder
                        aspect: listSelection
                      )
                    )
                    createNewApplication: true
                    createNewBuilder: true
                  )
                 )
               
              )
              handles: (Any 0.808108108108108 1.0)
            )
           (HorizontalPanelViewSpec
              name: 'BottonPanel'
              layout: (LayoutFrame 0 0 -30 1 0 1 0 1)
              horizontalLayout: fitSpace
              verticalLayout: center
              horizontalSpace: 3
              verticalSpace: 3
              reverseOrderIfOKAtLeft: true
              component: 
             (SpecCollection
                collection: (
                 (ActionButtonSpec
                    label: 'Cancel'
                    name: 'CancelButton'
                    translateLabel: true
                    model: doCancel
                    extent: (Point 295 22)
                  )
                 (ActionButtonSpec
                    label: 'OK'
                    name: 'OKButton'
                    translateLabel: true
                    model: doAccept
                    isDefault: true
                    defaultable: true
                    extent: (Point 296 22)
                  )
                 )
               
              )
            )
           )
         
        )
      )

    "Modified: / 27-02-2013 / 23:23:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LintRuleSelectionDialog methodsFor:'accessing'!

ruleset: ruleset
    self rulesetHolder value: ruleset

    "Created: / 27-02-2013 / 23:36:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

selection

    ^self selectionHolder value

    "Created: / 25-08-2010 / 14:10:03 / Jan Vrany <enter your email here>"
!

selection: anObject

    self selectionHolder value: anObject

    "Created: / 25-08-2010 / 14:09:40 / Jan Vrany <enter your email here>"
!

selectionAsRule

    self rulesetHolder value rules: self selection.
    ^self rulesetHolder value.

    "Created: / 25-08-2010 / 14:10:58 / Jan Vrany <enter your email here>"
    "Modified: / 27-02-2013 / 23:40:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LintRuleSelectionDialog methodsFor:'actions'!

hideResultView

    detailsShown == true ifFalse:[^self].

    variablePanel shown ifFalse:[^self].

    relativeCorners := variablePanel relativeCorners.

    variablePanel
        relativeCorners:#( 0.99 1.0 );
        resizeSubviews.
    detailsShown := false.

    "Created: / 10-02-2007 / 11:39:10 / janfrog"
    "Modified: / 24-07-2010 / 15:30:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

showResultView
    detailsShown == true ifTrue:[^self].
    variablePanel
        relativeCorners:relativeCorners ? #(0.5 1.0);
        resizeSubviews.
    detailsShown := true.

    "Created: / 10-02-2007 / 11:38:26 / janfrog"
    "Modified: / 24-07-2010 / 15:30:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LintRuleSelectionDialog methodsFor:'aspects'!

allRulesHolder

    ^[(RBCompositeLintRule allRules) rules]

    "Created: / 15-04-2010 / 20:09:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

listSelection
    "return/create the 'listSelection' value holder (automatically generated)"

    listSelection isNil ifTrue:[
        listSelection := ValueHolder new.
    ].
    ^ listSelection
!

listSelection:something
    "set the 'listSelection' value holder (automatically generated)"

    listSelection := something.
!

modeHolder

    ^[#select]

    "Created: / 15-04-2010 / 20:13:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

rulesetHolder
    "return/create the 'rulesetHolder' value holder (automatically generated)"

    rulesetHolder isNil ifTrue:[
        rulesetHolder := ValueHolder new.
        rulesetHolder addDependent:self.
    ].
    ^ rulesetHolder
!

rulesetHolder:something
    "set the 'rulesetHolder' value holder (automatically generated)"

    |oldValue newValue|

    rulesetHolder notNil ifTrue:[
        oldValue := rulesetHolder value.
        rulesetHolder removeDependent:self.
    ].
    rulesetHolder := something.
    rulesetHolder notNil ifTrue:[
        rulesetHolder addDependent:self.
    ].
    newValue := rulesetHolder value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:rulesetHolder.
    ].
!

rulesetList
    "return/create the 'rulesetList' value holder (automatically generated)"

    rulesetList isNil ifTrue:[
        rulesetList := RBCompositeLintRule rulesets asList.
        rulesetList addDependent:self.
    ].
    ^ rulesetList

    "Modified: / 27-02-2013 / 23:07:28 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

rulesetList:something
    "set the 'rulesetList' value holder (automatically generated)"

    |oldValue newValue|

    rulesetList notNil ifTrue:[
        oldValue := rulesetList value.
        rulesetList removeDependent:self.
    ].
    rulesetList := something.
    rulesetList notNil ifTrue:[
        rulesetList addDependent:self.
    ].
    newValue := rulesetList value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:rulesetList.
    ].
!

rulesetNameHolder
    "return/create the 'rulesetNameHolder' value holder (automatically generated)"

    rulesetNameHolder isNil ifTrue:[
        rulesetNameHolder := self rulesetHolder value name asValue.
        rulesetNameHolder addDependent:self.
    ].
    ^ rulesetNameHolder

    "Modified: / 27-02-2013 / 23:42:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

rulesetNameHolder:something
    "set the 'rulesetNameHolder' value holder (automatically generated)"

    |oldValue newValue|

    rulesetNameHolder notNil ifTrue:[
        oldValue := rulesetNameHolder value.
        rulesetNameHolder removeDependent:self.
    ].
    rulesetNameHolder := something.
    rulesetNameHolder notNil ifTrue:[
        rulesetNameHolder addDependent:self.
    ].
    newValue := rulesetNameHolder value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:rulesetNameHolder.
    ].
!

rulesetNameList
    "return/create the 'rulesetNameList' value holder (automatically generated)"

    rulesetNameList isNil ifTrue:[
        rulesetNameList := ValueHolder new.
    ].
    ^ rulesetNameList
!

rulesetNameList:something
    "set the 'rulesetNameList' value holder (automatically generated)"

    rulesetNameList := something.
!

selectionHolder
    "return/create the 'selectionHolder' value holder (automatically generated)"

    selectionHolder isNil ifTrue:[
        selectionHolder := ValueHolder new.
    ].
    ^ selectionHolder
! !

!LintRuleSelectionDialog methodsFor:'callbacks - post build'!

postBuildVariablePanel: aPanel

    variablePanel := aPanel.

    "Created: / 24-07-2010 / 15:05:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LintRuleSelectionDialog methodsFor:'change & update'!

update:something with:aParameter from:changedObject
    "Invoked when an object that I depend upon sends a change notification."

    "stub code automatically generated - please change as required"

    changedObject == rulesetList ifTrue:[
        self updateRulesetNameList.
         ^ self.
    ].
    changedObject == rulesetHolder ifTrue:[
        self rulesetNameHolder value: self rulesetHolder value name.
        self selection: self rulesetHolder value flattened.
         ^ self.
    ].
    changedObject == rulesetNameHolder ifTrue:[
        self updateRulesetHolder.
         ^ self.
    ].
    super update:something with:aParameter from:changedObject

    "Modified: / 27-02-2013 / 23:27:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

updateRulesetHolder
    | ruleset |    

    self rulesetHolder value name == self rulesetNameHolder value ifTrue:[
        ^self.
    ].

    (self rulesetNameList value notNil and:[self rulesetNameHolder value asString = self rulesetNameList value last asString]) ifTrue:[
        ruleset := RBCompositeLintRule new.
        ruleset name: ('New Rule Set ' , (self rulesetList size + 1) printString).
        self rulesetList add: ruleset.
        RBCompositeLintRule rulesets add: ruleset.
        self rulesetNameHolder value: ruleset name.
    ] ifFalse:[
        | idx |
        idx := self rulesetNameList value indexOf: self rulesetNameHolder value.
        ruleset := self rulesetList at: idx.
    ].
    self rulesetHolder value: ruleset.

    "Created: / 27-02-2013 / 23:15:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

updateRulesetNameList

    self rulesetNameList value: 
        ((self rulesetList collect:[:e|e name])
            add: 'New Ruleset...' asText allItalic;
            yourself)

    "Created: / 27-02-2013 / 23:08:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LintRuleSelectionDialog methodsFor:'hooks'!

commonPostBuild
    self updateRulesetNameList.

    "Created: / 27-02-2013 / 23:10:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LintRuleSelectionDialog class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libtool/Tools__LintRuleSelectionDialog.st,v 1.5 2013-07-31 16:08:52 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libtool/Tools__LintRuleSelectionDialog.st,v 1.5 2013-07-31 16:08:52 cg Exp $'
!

version_HG

    ^ '$Changeset: <not expanded> $'
!

version_SVN
    ^ '$Id: Tools__LintRuleSelectionDialog.st,v 1.5 2013-07-31 16:08:52 cg Exp $'
! !

